install 57 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804805806807808809810811812813814815816817818819820821822823824825826827828829830831832833834835836837838839840841842843844845846847848849850851852853854855856857858859860861862863864865866867868869870871872873874875876877878879880881882883884885886887888889890891892893894895896897898899900901902903904905906907908909910911912913914915916917918919920921922923924925926927928929930931932933934935936937938939940941942943944945946947948949950951952953954955956957958959960961962963964965966967968969970971972973974975976977978979980981982983984985986987988989990991992993994995996997998999100010011002100310041005100610071008100910101011101210131014101510161017101810191020102110221023102410251026102710281029103010311032103310341035103610371038103910401041104210431044104510461047104810491050105110521053105410551056105710581059106010611062106310641065106610671068106910701071107210731074107510761077107810791080108110821083108410851086108710881089109010911092109310941095109610971098109911001101110211031104110511061107110811091110111111121113111411151116111711181119112011211122112311241125112611271128112911301131113211331134113511361137113811391140114111421143114411451146114711481149115011511152115311541155115611571158115911601161116211631164116511661167116811691170117111721173117411751176117711781179118011811182118311841185118611871188118911901191119211931194119511961197119811991200120112021203120412051206120712081209121012111212121312141215121612171218121912201221122212231224122512261227122812291230123112321233123412351236123712381239124012411242124312441245124612471248124912501251125212531254125512561257125812591260126112621263126412651266126712681269127012711272127312741275127612771278127912801281128212831284128512861287128812891290129112921293129412951296129712981299130013011302130313041305130613071308130913101311131213131314131513161317131813191320132113221323132413251326132713281329133013311332133313341335133613371338133913401341134213431344134513461347134813491350135113521353135413551356135713581359136013611362136313641365136613671368136913701371137213731374137513761377137813791380138113821383138413851386138713881389139013911392139313941395139613971398139914001401140214031404140514061407140814091410141114121413141414151416141714181419142014211422142314241425142614271428142914301431143214331434143514361437143814391440144114421443144414451446144714481449145014511452145314541455145614571458145914601461146214631464146514661467146814691470147114721473147414751476147714781479148014811482148314841485148614871488148914901491149214931494149514961497149814991500150115021503150415051506150715081509151015111512151315141515151615171518151915201521152215231524152515261527152815291530153115321533153415351536153715381539154015411542154315441545154615471548154915501551155215531554155515561557155815591560156115621563156415651566156715681569157015711572157315741575157615771578157915801581158215831584158515861587158815891590159115921593159415951596159715981599160016011602160316041605160616071608160916101611161216131614161516161617161816191620162116221623162416251626162716281629163016311632163316341635163616371638163916401641164216431644164516461647164816491650165116521653165416551656165716581659166016611662166316641665166616671668166916701671167216731674167516761677167816791680168116821683168416851686168716881689169016911692169316941695169616971698169917001701170217031704170517061707170817091710171117121713171417151716171717181719172017211722172317241725172617271728172917301731173217331734173517361737
  1. #!/bin/bash
  2. #################################################################
  3. # auto-mediawiki #
  4. # Instala un servidor LAMP (Linux+Apache+MySQL+PHP) e instala #
  5. # MediaWiki y lo configura. #
  6. # #
  7. # Guzman Castanedo Villalba (guzman@castanedo.es) Junio 2018 #
  8. # GPLv3 (https://www.gnu.org/licenses/gpl.html) #
  9. #################################################################
  10. comprobarError() {
  11. # Permite comprobar si se ha producido un error y de serlo devuelve un código de error
  12. # comprobarError exitNum codeNum extraInfo
  13. # 1xx: Servidor Web
  14. # 2xx: Base de Datos
  15. # 3xx: PHP
  16. # 4xx: SSL/TLS
  17. # 5xx: MediaWiki
  18. # 6xx: Moodle
  19. # 7xx: Backup automático
  20. # 8xx: Dependencias
  21. # 9xx: Servicios & Firewall
  22. type="ERROR"
  23. exitNum=$1
  24. shift
  25. codeNum=$1
  26. shift
  27. extraInfo=$@
  28. case $codeNum in
  29. 1)
  30. error="$type $codeNum:\tInstalación interrumpida por el usuario.\n"
  31. ;;
  32. 2)
  33. error="$type $codeNum:\tError interno (selección express).\n"
  34. ;;
  35. 3)
  36. error="$type $codeNum:\tError interno (selección avanzada).\n"
  37. ;;
  38. 4)
  39. error="\n$type $codeNum:\tEl archivo '"$(realpath $extraInfo)"' no existe.\n"
  40. ;;
  41. 5)
  42. error="\n$type $codeNum:\tEl directorio '"$(realpath $extraInfo)"' no existe.\n"
  43. ;;
  44. 6)
  45. error="$type $codeNum:\tError interno (selección SSL/TLS).\n"
  46. ;;
  47. 100)
  48. error="$type $codeNum:\tError interno (selección del servidor web).\n"
  49. ;;
  50. 101)
  51. error="\n$type $codeNum:\tError al instalar Apache2.\nDetalles:\n$extraInfo\n"
  52. ;;
  53. 102)
  54. error="\n$type $codeNum:\tError al instalar Nginx.\nDetalles:\n$extraInfo\n"
  55. ;;
  56. 103)
  57. error="\n$type $codeNum:\tError al nstalar repositorio 'epel-release'.\nDetalles:\n$extraInfo\n"
  58. ;;
  59. 104)
  60. error="\n$type $codeNum:\tError interno (instalación Apache2).\n"
  61. ;;
  62. 105)
  63. error="\n$type $codeNum:\tError interno (instalación Nginx).\n"
  64. ;;
  65. 106)
  66. type="WARNING"
  67. error="\n$type $codeNum:\tImposible instalar 'info.php'.\n"
  68. ;;
  69. 107)
  70. error="\n$type $codeNum:\tError al configurar Nginx.\n"
  71. ;;
  72. 108)
  73. error="\n$type $codeNum:\tError al configurar Apache2.\n"
  74. ;;
  75. 200)
  76. error="$type $codeNum:\tError interno (selección de base de datos).\n"
  77. ;;
  78. 201)
  79. error="\n$type $codeNum:\tError al instalar MySQL.\nDetalles:\n$extraInfo\n"
  80. ;;
  81. 202)
  82. error="\n$type $codeNum:\tError al instalar MariaDB.\nDetalles:\n$extraInfo\n"
  83. ;;
  84. 203)
  85. error="\n$type $codeNum:\tError interno (instalación MySQL).\n"
  86. ;;
  87. 204)
  88. error="\n$type $codeNum:\tError interno (instalación MariaDB).\n"
  89. ;;
  90. 205)
  91. error="\n$type $codeNum:\t$DIST no incluye MySQL en sus repositorios.\n"
  92. ;;
  93. 206)
  94. type="WARNING"
  95. error="\n$type $codeNum:\tUsuario 'root' ya dispone de contraseña."
  96. ;;
  97. 207)
  98. error="\n$type $codeNum:\tImposible cambiar la contraseña de 'root'."
  99. ;;
  100. 208)
  101. error="\n$type $codeNum:\tImposible desactivar acceso 'root' desde el exterior."
  102. ;;
  103. 209)
  104. error="\n$type $codeNum:\tImposible eliminar usuarios anónimos."
  105. ;;
  106. 210)
  107. type="WARNING"
  108. error="\n$type $codeNum:\tImposible eliminar bases de datos de pruebas."
  109. ;;
  110. 211)
  111. type="WARNING"
  112. error="\n$type $codeNum:\tImposible eliminar los permisos de las bases de datos de pruebas."
  113. ;;
  114. 212)
  115. error="\n$type $codeNum:\tImposible recargar base de datos."
  116. ;;
  117. 213)
  118. error="\n$type $codeNum:\tImposible configurar SQL.\n"
  119. ;;
  120. 214)
  121. type="WARNING"
  122. error="\n$type $codeNum:\tSQL ya está configurado."
  123. ;;
  124. 300)
  125. error="\n$type $codeNum:\tError interno (instalación PHP-7.2).\n"
  126. ;;
  127. 301)
  128. error="\n$type $codeNum:\tError interno (Web Server no seleccionado).\n"
  129. ;;
  130. 302)
  131. error="\n$type $codeNum:\tError al instalar PHP-7.2.\nDetalles:\n$extraInfo\n"
  132. ;;
  133. 303)
  134. error="\n$type $codeNum:\tError al instalar Repositorio Remi.\nDetalles:\n$extraInfo\n"
  135. ;;
  136. 304)
  137. error="\n$type $codeNum:\tSistema Operativo no compatible con PHP-7.2 ($OS $DIST $REV).\n"
  138. ;;
  139. 305)
  140. error="\n$type $codeNum:\tImposible configurar PHP-7.2.\n"
  141. ;;
  142. 401)
  143. error="\n$type $codeNum:\tError al instalar 'certbot' (Let's Encrypt).\n"
  144. ;;
  145. 501)
  146. error="\n$type $codeNum:\tImposible descargar MediaWiki-1.31.0.\n"
  147. ;;
  148. 502)
  149. error="\n$type $codeNum:\tImposible configurar MediaWiki-1.31.0.\n"
  150. ;;
  151. 503)
  152. type="WARNING"
  153. error="\n$type $codeNum:\tYa existe una copia configurada de MediaWiki en el dominio: '$extraInfo'."
  154. ;;
  155. 601)
  156. error="\n$type $codeNum:\tImposible descargar Moodle-3.5.1.\n"
  157. ;;
  158. 602)
  159. error="\n$type $codeNum:\tImposible configurar Moodle-3.5.1.\n"
  160. ;;
  161. 603)
  162. type="WARNING"
  163. error="\n$type $codeNum:\tYa existe una copia configurada de Moodle en el dominio: '$extraInfo'."
  164. ;;
  165. 604)
  166. error="\n$type $codeNum:\tImposible configurar SELinux.\n"
  167. ;;
  168. 605)
  169. error="\n$type $codeNum:\tImposible instalar 'policycoreutils-python'.Detalles:\n$extraInfo\n"
  170. ;;
  171. 800)
  172. error="$type $codeNum:\tEs necesario ser root ('sudo $0').\n"
  173. ;;
  174. 801)
  175. error="$type $codeNum:\t'whiptail' no instalado.\n"
  176. ;;
  177. 802)
  178. error="$type $codeNum:\t'hostnamectl' no instalado.\n"
  179. ;;
  180. 803)
  181. error="$type $codeNum:\t'apt-get' no instalado.\n"
  182. ;;
  183. 804)
  184. error="$type $codeNum:\t'yum' no instalado.\n"
  185. ;;
  186. 805)
  187. error="\n$type $codeNum:\tImposible actualizar repositorio\nDetalles:\n$extraInfo.\n"
  188. ;;
  189. 806)
  190. error="$type $codeNum:\t'ufw' no instalado.\n"
  191. ;;
  192. 807)
  193. error="$type $codeNum:\t'firewall-cmd' no instalado.\n"
  194. ;;
  195. 808)
  196. error="$type $codeNum:\t'tput' no instalado.\nDetalles:\n$extraInfo\n"
  197. ;;
  198. 809)
  199. error="$type $codeNum:\t'sed' no instalado.\nDetalles:\n$extraInfo\n"
  200. ;;
  201. 810)
  202. error="$type $codeNum:\t'curl' no instalado.\nDetalles:\n$extraInfo\n"
  203. ;;
  204. 811)
  205. error="$type $codeNum:\t'tar' no instalado.\nDetalles:\n$extraInfo\n"
  206. ;;
  207. 812)
  208. error="$type $codeNum:\t'gzip' no instalado.\nDetalles:\n$extraInfo\n"
  209. ;;
  210. 813)
  211. error="$type $codeNum:\t'bzip2' no instalado.\nDetalles:\n$extraInfo\n"
  212. ;;
  213. 814)
  214. error="$type $codeNum:\t'xz' no instalado.\nDetalles:\n$extraInfo\n"
  215. ;;
  216. 815)
  217. error="$type $codeNum:\t'openssl' no instalado.\nDetalles:\n$extraInfo\n"
  218. ;;
  219. 816)
  220. error="$type $codeNum:\t'find' no instalado.\n"
  221. ;;
  222. 900)
  223. error="$type $codeNum:\tError interno (habilitar servicio).\n"
  224. ;;
  225. 901)
  226. error="$type $codeNum:\tImposible encender servicio '$extraInfo'.\n"
  227. ;;
  228. 902)
  229. error="$type $codeNum:\tImposible habilitar servicio '$extraInfo' durante el arranque.\n"
  230. ;;
  231. 903)
  232. error="$type $codeNum:\tError interno (deshabilitar servicio).\n"
  233. ;;
  234. 904)
  235. error="$type $codeNum:\tImposible parar servicio '$extraInfo'.\n"
  236. ;;
  237. 905)
  238. error="$type $codeNum:\tImposible deshabilitar servicio '$extraInfo' durante el arranque.\n"
  239. ;;
  240. 906)
  241. type="WARNING"
  242. error="\n$type $codeNum:\tImposible añadir regla al cortafuegos ('$extraInfo').\n"
  243. ;;
  244. 907)
  245. type="WARNING"
  246. error="\n$type $codeNum:\tImposible encender cortafuegos.\n"
  247. ;;
  248. 908)
  249. error="\n$type $codeNum:\tError interno (instalar Virtual Host).\n"
  250. ;;
  251. 909)
  252. error="\n$type $codeNum:\tVirtual Host '$extraInfo' no existe.\n"
  253. ;;
  254. 910)
  255. error="\n$type $codeNum:\tImposible copiar Virtual Host '$extraInfo'.\n"
  256. ;;
  257. 911)
  258. error="\n$type $codeNum:\tImposible activar Virtual Host '$extraInfo'.\n"
  259. ;;
  260. 912)
  261. error="\n$type $codeNum:\tError interno (recargar servicio).\n"
  262. ;;
  263. 913)
  264. error="\n$type $codeNum:\tImposible recargar servicio '$extraInfo'.\n"
  265. ;;
  266. *)
  267. error="ERROR 13:\tError interno (comprobación de errores)\n"
  268. exitNum=1
  269. codeNum=13
  270. ;;
  271. esac
  272. if [ $exitNum -ne 0 ];then
  273. echo -en "$error" | tee -a $logFile
  274. if [ $type = "ERROR" ];then
  275. exit $codeNum
  276. fi
  277. fi
  278. unset error exitNum codeNum type
  279. }
  280. OSInfo() {
  281. # Detecta el OS en el que se está ejecutando el programa, así como su versión
  282. echo -en "Detectando SO..." >> $logFile
  283. OS=$(uname -s)
  284. if [ $OS = "Linux" ]; then
  285. OS="GNU/Linux"
  286. if [ -f /etc/os-release ]; then
  287. DIST=$(grep ^NAME= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  288. REV=$(grep ^VERSION= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  289. ID_LIKE=$(grep ^ID_LIKE= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  290. VERSION=$(grep ^VERSION_ID= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  291. for i in $ID_LIKE; do
  292. #echo -en "$i\n"
  293. case $i in
  294. debian|ubuntu)
  295. debianOS=true
  296. break
  297. ;;
  298. rhel|fedora)
  299. rhelOS=true
  300. break
  301. ;;
  302. *)
  303. debianOS=false
  304. rhelOS=false
  305. ;;
  306. esac
  307. done
  308. elif [ -f /etc/debian-version ]; then
  309. # Familia Debian (Debian, Ubuntu, Linux Mint, ...)
  310. DIST="Debian"
  311. REV=""
  312. ID_LIKE="debian"
  313. VERSION=""
  314. debianOS=true
  315. elif [ -f /etc/redhat-release ]; then
  316. # Familia Red-Hat (RHEL, Fedora, CentOS, ...)
  317. DIST="Red-Hat"
  318. REV=""
  319. ID_LIKE="rhel"
  320. VERSION=""
  321. rhelOS=true
  322. else
  323. # Other Linux (No Soportado)
  324. DIST=""
  325. REV=""
  326. ID_LIKE=""
  327. VERSION=""
  328. fi
  329. else
  330. # UNIX, OS X, ... (No Soportado)
  331. DIST=$OS
  332. REV=""
  333. ID_LIKE=""
  334. VERSION=""
  335. fi
  336. echo -en " $OS $DIST $REV\n" >> $logFile
  337. HDInfo=$(df -h | head -1)"\n"$(df -h | grep ^/dev/sd)"\n"$(df -h | grep ^/dev/mapper)
  338. echo -en "$HDInfo\n" >> $logFile
  339. }
  340. comprobarRoot() {
  341. # Comprueba si se está ejecutando con privilegios de root
  342. comprobarError $(id -u) 800
  343. }
  344. comprobarDependencias() {
  345. # Comprueba si están instalados todos los programas necesarios.
  346. # En la mayoría de los casos, trata de instalarlos.
  347. # Comprobamos whiptail
  348. which whiptail > /dev/null 2>&1
  349. comprobarError $? 801
  350. # Comprobamos hostnamectl
  351. which hostnamectl > /dev/null 2>&1
  352. comprobarError $? 802
  353. which find > /dev/null 2>&1
  354. comprobarError $? 816
  355. if [ $debianOS = true ];then
  356. # Comprobamos apt-get
  357. which apt-get > /dev/null 2>&1
  358. comprobarError $? 803
  359. # Actualizamos base de datos del repositorio
  360. echo -en "Actualizando repositorio APT..." | tee -a $logFile
  361. result=$(apt-get -q -y update 2>&1)
  362. comprobarError $? 805 $result
  363. echo -en " OK.\n" | tee -a $logFile
  364. # Comprobamos Firewall (ufw)
  365. which ufw > /dev/null 2>&1
  366. comprobarError $? 806
  367. # Comprobamos tput
  368. which tput > /dev/null 2>&1
  369. if [ $? -ne 0 ];then
  370. result=$(apt-get -q -y ncurses-bin 2>&1)
  371. comprobarError $? 808 $result
  372. fi
  373. # Comprobar sed
  374. which sed > /dev/null 2>&1
  375. if [ $? -ne 0 ];then
  376. result=$(apt-get -q -y sed 2>&1)
  377. comprobarError $? 809 $result
  378. fi
  379. # Comprobar curl
  380. which curl > /dev/null 2>&1
  381. if [ $? -ne 0 ];then
  382. result=$(apt-get -q -y curl 2>&1)
  383. comprobarError $? 810 $result
  384. fi
  385. # Comprobamos tar, gzip, bzip2 y xz
  386. which tar > /dev/null 2>&1
  387. if [ $? -ne 0 ];then
  388. result=$(apt-get -q -y install tar 2>&1)
  389. comprobarError $? 811 $result
  390. fi
  391. which gzip > /dev/null 2>&1
  392. if [ $? -ne 0 ];then
  393. result=$(apt-get -q -y install gzip 2>&1)
  394. comprobarError $? 812 $result
  395. fi
  396. which bzip2 > /dev/null 2>&1
  397. if [ $? -ne 0 ];then
  398. result=$(apt-get -q -y install bzip2 2>&1)
  399. comprobarError $? 813 $result
  400. fi
  401. which xz > /dev/null 2>&1
  402. if [ $? -ne 0 ];then
  403. result=$(apt-get -q -y install xz-utils 2>&1)
  404. comprobarError $? 814 $result
  405. fi
  406. which openssl > /dev/null 2>&1
  407. if [ $? -ne 0 ];then
  408. result=$(apt-get -q -y install openssl 2>&1)
  409. comprobarError $? 815 $result
  410. fi
  411. fi
  412. if [ $rhelOS = true ]; then
  413. # Comprobamos yum
  414. which yum > /dev/null 2>&1
  415. comprobarError $? 804
  416. # Actualizamos base de datos del repositorio
  417. echo -en "Actualizando repositorio YUM..." | tee -a $logFile
  418. result=$(yum -y makecache 2>&1)
  419. comprobarError $? 805 $result
  420. echo -en " OK.\n" | tee -a $logFile
  421. # Comprobamos Firewall (firewall-cmd)
  422. which firewall-cmd > /dev/null 2>&1
  423. comprobarError $? 807
  424. # Comprobamos tput
  425. which tput > /dev/null 2>&1
  426. if [ $? -ne 0 ];then
  427. result=$(yum -y ncurses 2>&1)
  428. comprobarError $? 808 $result
  429. fi
  430. # Comprobar sed
  431. which sed > /dev/null 2>&1
  432. if [ $? -ne 0 ];then
  433. result=$(yum -y sed 2>&1)
  434. comprobarError $? 809 $result
  435. fi
  436. # Comprobar curl
  437. which curl > /dev/null 2>&1
  438. if [ $? -ne 0 ];then
  439. result=$(yum -y curl 2>&1)
  440. comprobarError $? 810 $result
  441. fi
  442. # Comprobamos tar, gzip, bzip2 y xz
  443. which tar > /dev/null 2>&1
  444. if [ $? -ne 0 ];then
  445. result=$(yum -y install tar 2>&1)
  446. comprobarError $? 811 $result
  447. fi
  448. which gzip > /dev/null 2>&1
  449. if [ $? -ne 0 ];then
  450. result=$(yum -y install gzip 2>&1)
  451. comprobarError $? 812 $result
  452. fi
  453. which bzip2 > /dev/null 2>&1
  454. if [ $? -ne 0 ];then
  455. result=$(yum -y install bzip2 2>&1)
  456. comprobarError $? 813 $result
  457. fi
  458. which xz > /dev/null 2>&1
  459. if [ $? -ne 0 ];then
  460. result=$(yum -y install xz 2>&1)
  461. comprobarError $? 814 $result
  462. fi
  463. which openssl > /dev/null 2>&1
  464. if [ $? -ne 0 ];then
  465. result=$(yum -y install openssl 2>&1)
  466. comprobarError $? 815 $result
  467. fi
  468. fi
  469. }
  470. inicializarVariables() {
  471. # Inicializa las variables que necesitan de un estado previo
  472. debianOS=false
  473. rhelOS=false
  474. apacheOn=false
  475. nginxOn=false
  476. mySQLOn=false
  477. mariaDBOn=false
  478. phpOn=false
  479. sslOn=false
  480. letsEncryptOn=false
  481. mediaWikiOn=false
  482. moodleOn=false
  483. infoPHPOn=false
  484. backupOn=false
  485. hostname=""
  486. logFile="./."$(basename $0)".log"
  487. maxUpload="100M"
  488. webServerName=""
  489. webServerUser=""
  490. webServerGroup=""
  491. sqlServerName=""
  492. phpFPMName=""
  493. nombreMediaWiki=""
  494. dominioMediaWiki=""
  495. passwdMediaWiki=""
  496. nombreMoodle=""
  497. nombreCortoMoodle=""
  498. dominioMoodle=""
  499. passwdMoodle=""
  500. }
  501. instalacionExpress() {
  502. # Permite una instalación rápida, haciendo el menor número de preguntas
  503. apacheOn=true
  504. mariaDBOn=true
  505. phpOn=true
  506. sslOn=true
  507. letsEncryptOn=true
  508. mediaWikiOn=true
  509. moodleOn=true
  510. backupOn=true
  511. # Preguntas mínimas
  512. establecerFQDN
  513. leerSQLPasswd
  514. mostrarMediaWiki
  515. mostrarMoodle
  516. }
  517. mostrarBienvenida() {
  518. # Pantalla de bienvenida y muestra SO y estado de los discos
  519. ANCHO=$(tput cols)
  520. ALTO=$(tput lines)
  521. if [ $debianOS = false ] && [ $rhelOS = false ]; then
  522. whiptail --title "ERROR S.O. NO SOPORTADO" --msgbox "Este script automatiza la creación de una web MediaWiki SOLO para distribuciones Linux de la familia Debian (Ubuntu, Linux Mint, ...) y de la familia Red-Hat (CentOS, Fedora, ...).\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Salir"
  523. exit 1
  524. fi
  525. whiptail --title "INSTALACION MEDIAWIKI" --yesno "Este script automatiza completamente la instalación de una WIKI y un CAMPUS VIRTUAL.\nPara ello instala un servidor LAMP, el software MediaWiki y configura todo lo necesario.\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --yes-button "Continuar" --no-button "Salir"
  526. comprobarError $? 1
  527. }
  528. mostrarExpress() {
  529. # Pantalla de elección entre instalación express o avanzada
  530. express=$(whiptail --title "INSTALACION EXPRESS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nLa instalación express instala Apache2, MariaDB, PHP-7, Let's Encrypt, MediaWiki, Moodle y backups automático.\nSeleccione el tipo de instalación que desee:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  531. "Express" "Instalación rápida" ON \
  532. "Avanzada" "Permite escoger todas las opciones disponibles" OFF \
  533. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  534. comprobarError $? 1
  535. case $express in
  536. Express)
  537. instalacionExpress
  538. # DECIDIR QUÉ OPCIONES SON LAS MÍNIMAS
  539. ;;
  540. Avanzada)
  541. mostrarAvanzada
  542. ;;
  543. *)
  544. comprobarError 1 2
  545. ;;
  546. esac
  547. unset express
  548. }
  549. mostrarAvanzada() {
  550. # Pantalla que permite instalar un servidor LAMP o LEMP
  551. webServer=$(whiptail --title "INSTALACION AVANZADA" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el tipo de Servidor Web que quieres instalar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  552. "LAMP" "GNU/Linux + Apache + MySQL/MariaDB + PHP-7" ON \
  553. "LEMP" "GNU/Linux + Nginx + MySQL/MariaDB + PHP-7" OFF \
  554. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  555. comprobarError $? 1
  556. for i in $webServer; do
  557. case $i in
  558. LAMP)
  559. apacheOn=true
  560. ;;
  561. LEMP)
  562. nginxOn=true
  563. ;;
  564. *)
  565. comprobarError 1 100
  566. ;;
  567. esac
  568. done
  569. # Opciones comunes
  570. establecerFQDN
  571. mostrarDatabase
  572. phpOn=true
  573. establecerMaxUpload
  574. mostrarComponentes
  575. mostrarConfirmacion
  576. unset webServer
  577. }
  578. mostrarComponentes() {
  579. # Pantalla de elección de componentes (SSL/TLS, MediaWiki, Moodle, InfoPHP y Backup)
  580. componentes=$(whiptail --title "INSTALACION AVANZADA" --checklist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge los componentes que quieres instalar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 5 \
  581. "SSL/TLS" "Instalar certificados para activar HTTPS" ON \
  582. "MediaWiki" "Instalar wiki con MediaWiki" ON \
  583. "Moodle" "Instalar campus virtual con Moodle" ON \
  584. "InfoPHP" "Instalar info.php (sólo para pruebas)" OFF \
  585. "Backup" "Programar backups automáticos" ON \
  586. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  587. comprobarError $? 1
  588. # Mejora: autodetección de componentes ya instalados
  589. for i in $componentes; do
  590. case $i in
  591. \"SSL/TLS\")
  592. # 2 Opciones: Let's Encrypt o Autofirmado
  593. mostrarSSL
  594. ;;
  595. \"MediaWiki\")
  596. mediaWikiOn=true
  597. mostrarMediaWiki
  598. ;;
  599. \"Moodle\")
  600. moodleOn=true
  601. mostrarMoodle
  602. ;;
  603. \"InfoPHP\")
  604. infoPHPOn=true
  605. ;;
  606. \"Backup\")
  607. BackupOn=true
  608. ;;
  609. *)
  610. comprobarError 1 3
  611. ;;
  612. esac
  613. done
  614. unset componentes
  615. }
  616. mostrarSSL() {
  617. # Pantalla que permite seleccionar el tipo de certificados
  618. ssl=$(whiptail --title "INSTALACION SSL/TLS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el tipo de Certificado SSL/TLS que quieres instalar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  619. "LetsEncrypt" "Compatible con todos los navegadores" ON \
  620. "Auto-Firmado" "Certificados auto-firmados (sólo para pruebas)" OFF \
  621. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  622. comprobarError $? 1
  623. for i in $ssl; do
  624. case $i in
  625. LetsEncrypt)
  626. sslOn=true
  627. letsEncryptOn=true
  628. ;;
  629. Auto-Firmados)
  630. sslOn=true
  631. ;;
  632. *)
  633. comprobarError 1 6
  634. ;;
  635. esac
  636. done
  637. unset ssl
  638. }
  639. mostrarMediaWiki(){
  640. # Pantalla que pregunta sobre las opciones necesarias para configurar MediaWiki
  641. # Introducir nombre wiki
  642. while [ -z "$nombreMediaWiki" ]; do
  643. nombreMediaWiki=$(whiptail --title "CONFIGURACION MEDIAWIKI" --inputbox "Introduzca el nombre de la Wiki:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  644. comprobarError $? 1
  645. done
  646. # Introducir dominio
  647. while [ -z "$dominioMediaWiki" ]; do
  648. dominioMediaWiki=$(whiptail --title "CONFIGURACION MEDIAWIKI" --inputbox "Introduzca el dominio/subdominio de la Wiki.\nTenga en cuenta que debes apuntar este dominio a la dirección IP de esta máquina mediante un registro DNS de tipo CNAME.\nSi quiere introducir varios dominios sepárelos con espacios. El primero será el principal.\nPor ejemplo: 'www.$hostname $hostname wiki.$hostname'" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) wiki.$hostname --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  649. comprobarError $? 1
  650. done
  651. cont=1
  652. serverName=""
  653. aliasMediaWiki=""
  654. for dominio in $dominioMediaWiki;do
  655. if [ $cont -eq 1 ];then
  656. # Dominio Principal (ServerName)
  657. serverName=$dominio
  658. else
  659. # Dominios Secundarios (ServerAlias)
  660. aliasMediaWiki=$aliasMediaWiki" "$dominio
  661. fi
  662. cont=$((cont + 1))
  663. done
  664. dominioMediaWiki=$serverName
  665. # Introducir contraseña
  666. control=false
  667. error=""
  668. while [ $control = false ]; do
  669. passwdMediaWiki=$(whiptail --title "CONFIGURACION MEDIAWIKI" --passwordbox "$error""Introduzca la contraseña para el usuario administrador 'admin':" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  670. comprobarError $? 1
  671. passwdMediaWiki2=$(whiptail --title "CONFIGURACION MEDIAWIKI" --passwordbox "Confirme la contraseña:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  672. comprobarError $? 1
  673. if [ -z "$passwdMediaWiki" ] || [ -z "$passwdMediaWiki2" ]; then
  674. error="ERROR: LA CONTRASEÑA NO PUEDE ESTAR VACIA.\n"
  675. elif [ $passwdMediaWiki != $passwdMediaWiki2 ];then
  676. error="ERROR: LAS CONTRASEÑAS NO COINCIDEN.\n"
  677. else
  678. control=true
  679. fi
  680. done
  681. unset control error passwdMediaWiki2 dominio cont serverName
  682. }
  683. mostrarMoodle() {
  684. # Pantalla que pregunta sobre las opciones necesarias para configurar Moodle
  685. # Introducir Nombre Moodle
  686. while [ -z "$nombreMoodle" ]; do
  687. nombreMoodle=$(whiptail --title "CONFIGURACION MOODLE" --inputbox "Introduzca el NOMBRE COMPLETO del campus virtual.\nPor ejemplo: 'Campus Virtual Ejemplo'." $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  688. comprobarError $? 1
  689. done
  690. # Introducir Nombre Corto Moodle
  691. while [ -z "$nombreCortoMoodle" ]; do
  692. nombreCortoMoodle=$(whiptail --title "CONFIGURACION MOODLE" --inputbox "Introduzca el NOMBRE CORTO del campus virtual.\nPor ejemplo: 'Ejemplo'." $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  693. comprobarError $? 1
  694. done
  695. nombreCortoMoodle=$(echo $nombreCortoMoodle | cut -d ' ' -f 1)
  696. # Introducir dominio
  697. while [ -z "$dominioMoodle" ]; do
  698. dominioMoodle=$(whiptail --title "CONFIGURACION MOODLE" --inputbox "Introduzca el dominio/subdominio del campus virtual.\nMoodle SÓLO permite un ÚNICO DOMINIO." $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) moodle.$hostname --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  699. comprobarError $? 1
  700. done
  701. cont=1
  702. serverName=""
  703. aliasMoodle=""
  704. for dominio in $dominioMoodle;do
  705. if [ $cont -eq 1 ];then
  706. # Dominio Principal (ServerName)
  707. serverName=$dominio
  708. else
  709. # Dominios Secundarios (ServerAlias)
  710. aliasMeoodle=$aliasMoodle" "$dominio
  711. fi
  712. cont=$((cont + 1))
  713. done
  714. dominioMoodle=$serverName
  715. # Introducir contraseña
  716. control=false
  717. error=""
  718. while [ $control = false ]; do
  719. passwdMoodle=$(whiptail --title "CONFIGURACION MOODLE" --passwordbox "$error""Introduzca la contraseña para el usuario administrador 'admin':" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  720. comprobarError $? 1
  721. passwdMoodle2=$(whiptail --title "CONFIGURACION MOODLE" --passwordbox "Confirme la contraseña:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  722. comprobarError $? 1
  723. if [ -z "$passwdMoodle" ] || [ -z "$passwdMoodle2" ]; then
  724. error="ERROR: LA CONTRASEÑA NO PUEDE ESTAR VACIA.\n"
  725. elif [ $passwdMoodle != $passwdMoodle2 ];then
  726. error="ERROR: LAS CONTRASEÑAS NO COINCIDEN.\n"
  727. else
  728. control=true
  729. fi
  730. done
  731. unset control error passwdMoodle2 dominio cont serverName aliasMoodle
  732. }
  733. mostrarConfirmacion() {
  734. # Pantalla que presenta una confirmación antes de realizar la instalación
  735. whiptail --title "INSTALACION" --yesno "ESTA TODO LISTO PARA LA INSTALACION.\n¿DESEA CONTINUAR?" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --yes-button "Instalar" --no-button "Salir"
  736. comprobarError $? 1
  737. }
  738. establecerFQDN() {
  739. # Configura el FQDN (dominio principal del servidor)
  740. while [ -z "$hostname" ]; do
  741. hostname=$(whiptail --title "FQDN" --inputbox "El nombre de dominio principal (FQDN) de este servidor es:\n"$(hostname)"\n\n¿Quieres cambiarlo por otro?" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Cambiar" --cancel-button "No Cambiar" 3>&1 1>&2 2>&3)
  742. if [ $? -eq 0 ] && [ ! -z "$hostname" ]; then
  743. hostnamectl set-hostname $hostname
  744. else
  745. hostname=$(hostname)
  746. fi
  747. done
  748. echo -en "Hostname: $hostname\n" >> $logFile
  749. }
  750. instalarApache() {
  751. # Instala Apache2
  752. if [ $debianOS = true ];then
  753. webServerName="apache2"
  754. result=$(apt-get -q -y install apache2 2>&1)
  755. comprobarError $? 101 $result
  756. elif [ $rhelOS = true ]; then
  757. webServerName="httpd"
  758. result=$(yum -y install httpd 2>&1)
  759. comprobarError $? 101 $result
  760. else
  761. comprobarError 1 104
  762. fi
  763. deshabilitarServicio $webServerName
  764. }
  765. configurarApache() {
  766. # Configura Apache2
  767. if [ $debianOS = true ];then
  768. apacheConfFile="./etc/apache2/apache2.conf"
  769. if [ ! -f $apacheConfFile ];then
  770. comprobarError 1 4 $apacheConfFile
  771. fi
  772. cp -f $apacheConfFile /etc/$webServerName/apache2.conf 2>/dev/null
  773. comprobarError $? 108
  774. webServerUser=$(grep ^User /etc/$webServerName/apache2.conf | cut -d ' ' -f 2)
  775. webServerGroup=$(grep ^Group /etc/$webServerName/apache2.conf | cut -d ' ' -f 2)
  776. if [ ! -L /etc/$webServerName/logs ];then
  777. ln -s /var/log/apache2 /etc/$webServerName/logs 2>/dev/null
  778. comprobarError $? 108
  779. fi
  780. # Activamos mod_rewrite (no viene activado por defecto)
  781. a2enmod rewrite >/dev/null 2>&1
  782. comprobarError $? 108
  783. elif [ $rhelOS = true ];then
  784. apacheConfFile="./etc/apache2/conf/httpd.conf"
  785. welcomeConfFile="/etc/apache2/conf.d/welcome.conf"
  786. if [ ! -f $apacheConfFile ];then
  787. comprobarError 1 4 $apacheConfFile
  788. fi
  789. cp -f $apacheConfFile /etc/$webServerName/conf/httpd.conf 2>/dev/null
  790. comprobarError $? 108
  791. if [ -f $welcomeConfFile ];then
  792. sed -i -e 's/^/#/' $welcomeConfFile
  793. comprobarError $? 108
  794. fi
  795. webServerUser=$(grep ^User /etc/$webServerName/conf/httpd.conf | cut -d ' ' -f 2)
  796. webServerGroup=$(grep ^Group /etc/$webServerName/conf/httpd.conf | cut -d ' ' -f 2)
  797. unset apacheConfFile welcomeConfFile
  798. fi
  799. if [ ! -d "/etc/$webServerName/sites-available" ];then
  800. mkdir "/etc/$webServerName/sites-available" 2>/dev/null
  801. comprobarError $? 5 "/etc/$webServerName/sites-available"
  802. fi
  803. if [ ! -d "/etc/$webServerName/sites-enabled" ]; then
  804. mkdir "/etc/$webServerName/sites-enabled" 2>/dev/null
  805. comprobarError $? 5 "/etc/$webServerName/sites-enabled"
  806. else
  807. # Eliminar Virtual Host por defecto
  808. if [ -f /etc/$webServerName/sites-enabled/000-default.conf ];then
  809. rm -f /etc/$webServerName/sites-enabled/000-default.conf 2>/dev/null
  810. fi
  811. fi
  812. }
  813. instalarNginx() {
  814. # Instala Nginx
  815. webServerName="nginx"
  816. if [ $debianOS = true ];then
  817. result=$(apt-get -q -y install nginx 2>&1)
  818. comprobarError $? 102 $result
  819. elif [ $rhelOS = true ]; then
  820. # Hay que instalar primero otro repositorio
  821. result=$(yum -y install epel-release)
  822. comprobarError $? 103 $result
  823. result=$(yum -y install nginx 2>&1)
  824. comprobarError $? 102 $result
  825. else
  826. comprobarError 1 105
  827. fi
  828. deshabilitarServicio $webServerName
  829. }
  830. configurarNginx() {
  831. # Configura Nginx
  832. rm -Rf "/etc/$webServerName/!(sites-available|sites-enabled)" 2>/dev/null
  833. comprobarError $? 107
  834. nginxConfFile="./etc/$webServerName"
  835. if [ -d "$nginxConfFile" ];then
  836. cp -Rf $nginxConfFile/* /etc/$webServerName/ 2>/dev/null
  837. comprobarError $? 107
  838. else
  839. comprobarError 1 5 "$nginxConfFile"
  840. fi
  841. if [ ! -d "/etc/$webServerName/sites-available" ];then
  842. mkdir "/etc/$webServerName/sites-available" 2>/dev/null
  843. comprobarError $? 5 "/etc/$webServerName/sites-available"
  844. fi
  845. if [ ! -d "/etc/$webServerName/sites-enabled" ]; then
  846. mkdir "/etc/$webServerName/sites-enabled" 2>/dev/null
  847. comprobarError $? 5 "/etc/$webServerName/sites-enabled"
  848. else
  849. # Eliminar Virtual Host por defecto
  850. if [ -f /etc/$webServerName/sites-enabled/default ];then
  851. rm -f /etc/$webServerName/sites-enabled/default 2>/dev/null
  852. fi
  853. fi
  854. # Configuramos Usuario y Grupo
  855. if [ $debianOS = true ];then
  856. webServerUser="www-data"
  857. webServerGroup=$webServerUser
  858. elif [ $rhelOS = true ];then
  859. webServerUser="nginx"
  860. webServerGroup=$webServerUser
  861. fi
  862. sed -i '/user /c\user '$webServerUser';' /etc/$webServerName/nginx.conf
  863. comprobarError $? 107
  864. unset nginxConfFile
  865. }
  866. instalarVirtualHost() {
  867. # Configuramos un Virtual Host para Apache o Nginx
  868. # Uso: instalarVirtualHost $root $virtualHost $dominio $alias
  869. if [ $# -ge 3 ];then
  870. rootVirtualHost=$(realpath $1)
  871. shift
  872. virtualHostFile=$(realpath $1)
  873. shift
  874. dominioVirtualHost=$1
  875. virtualHostName=$dominioVirtualHost".conf"
  876. shift
  877. aliasVirtualHost=$@
  878. else
  879. comprobarError 1 908
  880. fi
  881. if [ ! -f $virtualHostFile ];then
  882. comprobarError 1 909 $virtualHostName
  883. fi
  884. if [ $apacheOn = true ];then
  885. # Configuramos root, dominio y logs
  886. sed -i '/ServerName /c\\tServerName '"$dominioVirtualHost" $virtualHostFile
  887. comprobarError $? 908
  888. if [ ! -z "$aliasVirtualHost" ];then
  889. sed -i '/ServerName /a\\tServerAlias '"$aliasVirtualHost" $virtualHostFile
  890. comprobarError $? 908
  891. fi
  892. sed -i '/DocumentRoot /c\\tDocumentRoot '"$rootVirtualHost" $virtualHostFile
  893. comprobarError $? 908
  894. sed -i '/ErrorLog /c\\tErrorLog logs/'"$dominioVirtualHost"'-error.log' $virtualHostFile
  895. comprobarError $? 908
  896. sed -i '/CustomLog /c\\tCustomLog logs/'"$dominioVirtualHost"'-access.log common' $virtualHostFile
  897. comprobarError $? 908
  898. elif [ $nginxOn = true ];then
  899. # Configuramos root, dominio, logs y php-fpm.sock (NGINX)
  900. sed -i '/root /c\\troot '$rootVirtualHost';' "$virtualHostFile"
  901. comprobarError $? 908
  902. sed -i '/server_name /c\\tserver_name '"$dominioVirtualHost"' '"$aliasVirtualHost"';' $virtualHostFile
  903. comprobarError $? 908
  904. sed -i '/access_log /c\\taccess_log /var/log/nginx/'"$dominioVirtualHost"'-access.log;' $virtualHostFile
  905. comprobarError $? 908
  906. sed -i '/error_log /c\\terror_log /var/log/nginx/'"$dominioVirtualHost"'-error.log;' $virtualHostFile
  907. comprobarError $? 908
  908. socket=$(find /var/run/ -type s -name 'php*.sock')
  909. sed -i '/fastcgi_pass /c\\t\tfastcgi_pass unix:'"$socket"';' $virtualHostFile
  910. fi
  911. # Copiamos ficheros de configuración
  912. cp -f $virtualHostFile "/etc/$webServerName/sites-available/$virtualHostName" >> $logFile 2>&1
  913. comprobarError $? 910
  914. ln -s "/etc/$webServerName/sites-available/$virtualHostName" "/etc/$webServerName/sites-enabled/$virtualHostName" >> $logFile 2>&1
  915. comprobarError $? 911 $virtualHostName
  916. recargarServicio $webServerName
  917. unset rootVirtualHost dominioVirtualHost virtualHostFile virtualHostName aliasVirtualHost socket
  918. }
  919. mostrarDatabase() {
  920. # Pantalla que permite escoger entre instalar MariaDB o MySQL
  921. if [ $debianOS = true ]; then
  922. database=$(whiptail --title "BASE DE DATOS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge la base de datos que quieres usar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  923. "MariaDB" "Instalar la base de datos MariaDB (fork de MySQL)" ON \
  924. "MySQL" "Instalar la base de datos MySQL (uso no comercial)" OFF \
  925. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  926. comprobarError $? 1
  927. case $database in
  928. MariaDB)
  929. mariaDBOn=true
  930. ;;
  931. MySQL)
  932. mySQLOn=true
  933. ;;
  934. *)
  935. comprobarError 1 200
  936. ;;
  937. esac
  938. unset database
  939. elif [ $rhelOS = true ]; then
  940. whiptail --title "BASE DE DATOS" --yesno "Para su distribucion $OS $DIST $REV, sólo está disponible la base de datos MariaDB." $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --yes-button "Continuar" --no-button "Salir"
  941. comprobarError $? 1
  942. mariaDBOn=true
  943. else
  944. comprobarError 1 200
  945. fi
  946. # Otras opciones (contraseña)
  947. leerSQLPasswd
  948. }
  949. leerSQLPasswd() {
  950. # Pantalla para leer la contraseña para el usuario root de SQL
  951. control=false
  952. error=""
  953. # Leemos la contreseña (stdin) y confirmamos
  954. while [ $control = false ]; do
  955. sqlPasswd=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "$error""Introduzca la contraseña para el usuario 'root' de la base de datos:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  956. comprobarError $? 1
  957. sqlPasswd2=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "Confirme la contraseña:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  958. comprobarError $? 1
  959. #echo -en "SQL Password 1: $sqlPasswd\n"
  960. #echo -en "SQL Password 2: $sqlPasswd2\n"
  961. if [ -z "$sqlPasswd" ] || [ -z "$sqlPasswd2" ]; then
  962. error="ERROR: LA CONTRASEÑA NO PUEDE ESTAR VACIA.\n"
  963. elif [ $sqlPasswd != $sqlPasswd2 ];then
  964. error="ERROR: LAS CONTRASEÑAS NO COINCIDEN.\n"
  965. else
  966. control=true
  967. fi
  968. done
  969. #echo -en "SQL Password: $sqlPasswd\n"
  970. unset control error sqlPasswd2
  971. }
  972. establecerSQLPasswd() {
  973. # Establecemos SQL root passwd y securizamos BD (mysql_secure_installation)
  974. # Comprobamos si ya tiene una contraseña asignada
  975. mysql -e "FLUSH PRIVILEGES" >> $logFile 2>&1
  976. if [ $? -eq 0 ];then
  977. # Establecemos contraseña del usuario root (y desactivamos posibles plugins para forzar login por contraseña)
  978. mysql -e "UPDATE mysql.user SET plugin = '', Password = PASSWORD('$sqlPasswd') WHERE User = 'root'" >> $logFile 2>&1
  979. if [ $? -ne 0 ];then
  980. # Lo intentamos de otra forma (para versiones modernas de mysql)
  981. mysql -e "ALTER USER 'root'@'localhost' IDENTIFIED WITH mysql_native_password BY '$sqlPasswd'" >> $logFile 2>&1
  982. comprobarError $? 207
  983. fi
  984. # Aplicamos el cambio de contraseña
  985. mysql -e "FLUSH PRIVILEGES" >> $logFile 2>&1
  986. # Desactivamos acceso root desde el exterior (solo localhost)
  987. mysql -u root --password=$sqlPasswd -e "DELETE FROM mysql.user WHERE User='root' AND Host NOT IN ('localhost', '127.0.0.1', '::1')" >> $logFile 2>&1
  988. comprobarError $? 208
  989. # Eliminamos todos los usuarios anónimos
  990. mysql -u root --password=$sqlPasswd -e "DELETE FROM mysql.user WHERE User=''" >> $logFile 2>&1
  991. comprobarError $? 209
  992. # Eliminamos bases de datos 'test'
  993. mysql -u root --password=$sqlPasswd -e "DROP DATABASE IF EXISTS test" >> $logFile 2>&1
  994. comprobarError $? 210
  995. # Eliminamos privilegios de la base de datos 'test'
  996. mysql -u root --password=$sqlPasswd -e "DELETE FROM mysql.db WHERE Db='test' OR Db='test\\_%'" >> $logFile 2>&1
  997. comprobarError $? 211
  998. # Aplicamos los cambios
  999. mysql -u root --password=$sqlPasswd -e "FLUSH PRIVILEGES" >> $logFile 2>&1
  1000. comprobarError $? 212
  1001. else
  1002. comprobarError 1 206
  1003. fi
  1004. }
  1005. instalarMySQL() {
  1006. # Instala MySQL (sólo para Debian)
  1007. sqlServerName="mysql"
  1008. if [ $debianOS = true ];then
  1009. result=$(apt-get -q -y install mysql-server mysql-client 2>&1)
  1010. comprobarError $? 201 $result
  1011. elif [ $rhelOS = true ];then
  1012. # MySQL no disponible en RHEL. 2 opciones:
  1013. # 1) Instalar un repositorio adicional
  1014. # 2) No instalar MySQL en distribuciones RHEL
  1015. comprobarError 1 205
  1016. else
  1017. comprobarError 1 203
  1018. fi
  1019. deshabilitarServicio $sqlServerName
  1020. }
  1021. instalarMariaDB() {
  1022. # Instala MariaDB
  1023. sqlServerName="mariadb"
  1024. if [ $debianOS = true ];then
  1025. result=$(apt-get -q -y install mariadb-server mariadb-client 2>&1)
  1026. comprobarError $? 202 $result
  1027. elif [ $rhelOS = true ];then
  1028. result=$(yum -y install mariadb-server mariadb 2>&1)
  1029. comprobarError $? 202 $result
  1030. else
  1031. comprobarError 1 204
  1032. fi
  1033. deshabilitarServicio $sqlServerName
  1034. }
  1035. configurarSQL() {
  1036. # Configura BarracudaFS en mysql (necesario para Moodle)
  1037. # Configura MariaDB o MySQL
  1038. if [ $mariaDBOn = true ] && [ $debianOS = true ];then
  1039. sqlConfFile="/etc/mysql/my.cnf"
  1040. elif [ $mariaDBOn = true ] && [ $rhelOS = true ];then
  1041. sqlConfFile="/etc/my.cnf"
  1042. elif [ $mySQLOn = true ] && [ $debianOS = true ];then
  1043. sqlConfFile="/etc/mysql/my.cnf"
  1044. else
  1045. comprobarError 1 213
  1046. fi
  1047. if [ ! -f $sqlConfFile ];then
  1048. comprobarError 1 213
  1049. fi
  1050. grep "# Configuration for Moodle" $sqlConfFile >/dev/null 2>&1
  1051. if [ $? -ne 0 ];then
  1052. # Establecemos UTF8 (codificación de caracteres) y Barracuda (sistema de ficheros)
  1053. echo -en "\n# Configuration for Moodle\n" >> $sqlConfFile
  1054. echo -en "[client]\n" >> $sqlConfFile
  1055. echo -en "default-character-set = utf8mb4\n\n" >> $sqlConfFile
  1056. echo -en "[mysqld]\n" >> $sqlConfFile
  1057. echo -en "innodb_file_format = Barracuda\n" >> $sqlConfFile
  1058. echo -en "innodb_file_per_table = 1\n" >> $sqlConfFile
  1059. echo -en "innodb_large_prefix\n\n" >> $sqlConfFile
  1060. echo -en "character-set-server = utf8mb4\n" >> $sqlConfFile
  1061. echo -en "collation-server = utf8mb4_unicode_ci\n" >> $sqlConfFile
  1062. echo -en "skip-character-set-client-handshake\n\n" >> $sqlConfFile
  1063. echo -en "[mysql]\n" >> $sqlConfFile
  1064. echo -en "default-character-set = utf8mb4\n" >> $sqlConfFile
  1065. else
  1066. comprobarError 1 214
  1067. fi
  1068. unset sqlConfFile
  1069. }
  1070. instalarPHP() {
  1071. # Instalamos PHP-7 y los módulos PHP que necesitan MediaWiki y Moodle
  1072. if [ $debianOS = true ];then
  1073. if [ $apacheOn = true ]; then
  1074. result=$(apt-get -q -y install php libapache2-mod-php php-mysql php-intl php-mbstring php-xml php-apcu php-gd php-curl php-zip php-soap php-xmlrpc 2>&1)
  1075. comprobarError $? 302 $result
  1076. elif [ $nginxOn = true ];then
  1077. phpFPMName="php7.2-fpm"
  1078. result=$(apt-get -q -y install php-fpm php-mysql php-intl php-mbstring php-xml php-apcu php-gd php-curl php-zip php-soap php-xmlrpc 2>&1)
  1079. comprobarError $? 302 $result
  1080. deshabilitarServicio $phpFPMName
  1081. else
  1082. comprobarError 1 301
  1083. fi
  1084. elif [ $rhelOS = true ];then
  1085. # Necesitamos un repositorio adicional para PHP-7 (EPEL-RELEASE)
  1086. result=$(yum -y install epel-release yum-utils 2>&1)
  1087. comprobarError $? 103 $result
  1088. # Necesitamos un repositorio adicional para PHP-7 (REMI-RELEASE)
  1089. if [ ! -f /etc/yum.repos.d/remi-php72.repo ];then
  1090. if [ $VERSION = "7" ];then
  1091. result=$(yum -y install http://remi.mirrors.cu.be/enterprise/remi-release-7.rpm 2>&1)
  1092. comprobarError $? 303 $result
  1093. elif [ $VERSION = "6" ];then
  1094. result=$(yum -y install http://remi.mirrors.cu.be/enterprise/remi-release-6.rpm 2>&1)
  1095. comprobarError $? 303 $result
  1096. elif [ $VERSION = "28" ];then
  1097. result=$(yum -y install http://remi.mirrors.cu.be/fedora/remi-release-28.rpm 2>&1)
  1098. comprobarError $? 303 $result
  1099. elif [ $VERSION = "27" ];then
  1100. result=$(yum -y install http://remi.mirrors.cu.be/fedora/remi-release-27.rpm 2>&1)
  1101. comprobarError $? 303 $result
  1102. else
  1103. comprobarError 1 304
  1104. fi
  1105. fi
  1106. # Activamos repositorio remi-php72
  1107. result=$(yum-config-manager --enable remi-php72 2>&1)
  1108. comprobarError $? 303 $result
  1109. # Instalamos PHP-7.2
  1110. if [ $apacheOn = true ];then
  1111. result=$(yum -y install php php-mysql php-intl php-mbstring php-mcrypt php-xml php-pecl-apcu php-gd php-pear-Net-Curl php-pecl-zip php-soap php-xmlrpc 2>&1)
  1112. comprobarError $? 302 $result
  1113. elif [ $nginxOn = true ];then
  1114. phpFPMName="php-fpm"
  1115. result=$(yum -y install php php-fpm php-mysql php-intl php-mbstring php-mcrypt php-xml php-pecl-apcu php-gd php-pear-Net-Curl php-pecl-zip php-soap php-xmlrpc 2>&1)
  1116. comprobarError $? 302 $result
  1117. deshabilitarServicio $phpFPMName
  1118. else
  1119. comprobarError 1 301
  1120. fi
  1121. else
  1122. comprobarError 1 300
  1123. fi
  1124. }
  1125. configurarPHP() {
  1126. # Configura PHP para segurizarlo y establecer máximo de subida.
  1127. if [ $debianOS = true ];then
  1128. phpConfFile="./etc/php/php.ini.debian"
  1129. phpDest="/etc/php/7.2/cli/php.ini"
  1130. elif [ $rhelOS = true ];then
  1131. phpConfFile="./etc/php/php.ini.rhel"
  1132. phpDest="/etc/php.ini"
  1133. fi
  1134. if [ ! -f $phpConfFile ];then
  1135. comprobarError 1 4 "$phpConfFile"
  1136. fi
  1137. # Copiamos configuración
  1138. cp -f $phpConfFile $phpDest 2>/dev/null
  1139. comprobarError $? 305
  1140. # Configuramos cgi.fix_pathinfo
  1141. sed -i '/cgi.fix_pathinfo=/c\cgi.fix_pathinfo=0' $phpDest
  1142. comprobarError $? 305
  1143. # Configuramos post_max_size
  1144. sed -i '/post_max_size =/c\post_max_size = '$maxUpload $phpDest
  1145. comprobarError $? 305
  1146. # Configuramos upload_max_filesize
  1147. sed -i '/upload_max_filesize =/c\upload_max_filesize = '$maxUpload $phpDest
  1148. comprobarError $? 305
  1149. # Configurar php-fpm (sólo en RHEL con Nginx)
  1150. if [ $rhelOS = true ] && [ $nginxOn = true ];then
  1151. # Configurar Socket UNIX
  1152. phpConfFile="./etc/php/php-fpm.d/www.conf"
  1153. phpDest="/etc/php-fpm.d/www.conf"
  1154. if [ ! -f $phpConfFile ];then
  1155. comprobarError $? 4 "$phpConfFile"
  1156. fi
  1157. cp -f $phpConfFile $phpDest 2>/dev/null
  1158. comprobarError $? 305
  1159. # Configurar Permisos /var/lib/php
  1160. chown -R $webServerUser:$webServerGroup /var/lib/php/
  1161. comprobarError $? 305
  1162. fi
  1163. unset phpConfFile phpDest
  1164. }
  1165. establecerMaxUpload() {
  1166. # Pantalla para establecer el máximo de subida al servidor (vía PHP)
  1167. control=false
  1168. error=""
  1169. while [ $control = false ];do
  1170. maxUpload2=$(whiptail --title "PHP MAX UPLOAD" --inputbox "$error""Introduzca el tamaño máximo permitido de los ficheros subidos al servidor:\n(<K:Kilobyte> <M:Megabyte> <G:Gigabyte>)" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) $maxUpload --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  1171. comprobarError $? 1
  1172. if [ -z "$maxUpload2" ];then
  1173. error="ERROR: NO PUEDES DEJAR ESTE PARÁMETRO VACIO.\n"
  1174. else
  1175. control=true
  1176. fi
  1177. done
  1178. maxUpload=$maxUpload2
  1179. unset control maxUpload2
  1180. }
  1181. instalarLetsEncrypt() {
  1182. # Instala certbot (para certificados Let's Encrypt)
  1183. # Comprobamos si cerbot está instalado
  1184. which certbot > /dev/null 2>&1
  1185. if [ $? -ne 0 ];then
  1186. # Descargar Let's Encrypt, hacer ejecutable e instalar
  1187. curl -o ./var/certbot https://dl.eff.org/certbot-auto 2>/dev/null
  1188. comprobarError $? 401
  1189. chmod 755 ./var/certbot 2>/dev/null
  1190. comprobarError $? 401
  1191. cp -f ./var/certbot /usr/bin/certbot 2>/dev/null
  1192. comprobarError $? 401
  1193. # Configurar /etc/cron.d/certbot para renovar automáticamente los certificados
  1194. echo -en "# certbot autorenew of the certificates twice a day\n" > /etc/cron.d/certbot
  1195. echo -en "SHELL=/bin/sh\n" >> /etc/cron.d/certbot
  1196. echo -en "PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin\n\n" >> /etc/cron.d/certbot
  1197. echo -en "# Job start twice per day (4am & 2pm) in a random minute" >> /etc/cron.d/certbot
  1198. echo -en "0 4,14 * * * python -c 'import random; import time; time.sleep(random.random() * 3600)' && certbot renew\n" >> /etc/cron.d/certbot
  1199. fi
  1200. }
  1201. habilitarServicio() {
  1202. # Arrancamos y habilitamos el servicio (con SystemD, Upstart o SystemV)
  1203. # Intentamos con systemctl (SystemD)
  1204. #echo -en "Habilitando Servicio '$1'" | tee -a $logFile
  1205. if [ $# -le 0 ];then
  1206. comprobarError 1 900
  1207. fi
  1208. which systemctl > /dev/null 2>&1
  1209. if [ $? -eq 0 ]; then
  1210. #echo -en " (SystemD)..." | tee -a $logFile
  1211. systemctl start $1 > /dev/null 2>&1
  1212. comprobarError $? 901 $1
  1213. systemctl enable $1 > /dev/null 2>&1
  1214. comprobarError $? 902 $1
  1215. else
  1216. # Intentamos con service (Upstart)
  1217. which service > /dev/null 2>&1
  1218. if [ $? -eq 0 ]; then
  1219. #echo -en " (Upstart)..." | tee -a $logFile
  1220. service $1 start > /dev/null 2>&1
  1221. comprobarError $? 901 $1
  1222. else
  1223. # Intentamos con init.d (SystemV)
  1224. #echo -en " (SystemV)..." | tee -a $logFile
  1225. /etc/init.d/$1 start > /dev/null 2>&1
  1226. comprobarError $? 901 $1
  1227. fi
  1228. # Intentamos habilitar en el arranque (Upstart)
  1229. which update-rc.d > /dev/null 2>&1
  1230. if [ $? -eq 0 ];then
  1231. update-rc.d $1 enable
  1232. comprobarError $? 902 $1
  1233. else
  1234. # Intentamos habilitar en el arranque (SystemV)
  1235. which chkconfig > /dev/null 2>&1
  1236. if [ $? -eq 0 ];then
  1237. chkconfig $1 on
  1238. comprobarError $? 902 $1
  1239. else
  1240. # ¿Qué mas opciones nos quedan?
  1241. comprobarError 1 902 $1
  1242. fi
  1243. fi
  1244. fi
  1245. # Mejora: comprobar si el servicio está parado
  1246. #echo -en " OK.\n" | tee -a $logFile
  1247. }
  1248. deshabilitarServicio() {
  1249. # Paramos y deshabilitamos el servicio (con SystemD, Upstart o SystemV)
  1250. # Intentamos con systemctl (SystemD)
  1251. #echo -en "Deshabilitando Servicio '$1'" | tee -a $logFile
  1252. if [ $# -le 0 ];then
  1253. comprobarError 1 903
  1254. fi
  1255. which systemctl > /dev/null 2>&1
  1256. if [ $? -eq 0 ]; then
  1257. #echo -en " (SystemD)..." | tee -a $logFile
  1258. systemctl stop $1 > /dev/null 2>&1
  1259. comprobarError $? 904 $1
  1260. systemctl disable $1 > /dev/null 2>&1
  1261. comprobarError $? 905 $1
  1262. else
  1263. # Intentamos con service (Upstart)
  1264. which service > /dev/null 2>&1
  1265. if [ $? -eq 0 ]; then
  1266. #echo -en " (Upstart)..." | tee -a $logFile
  1267. service $1 stop > /dev/null 2>&1
  1268. comprobarError $? 904 $1
  1269. else
  1270. # Intentamos con init.d (SystemV)
  1271. #echo -en " (SystemV)..." | tee -a $logFile
  1272. /etc/init.d/$1 stop > /dev/null 2>&1
  1273. comprobarError $? 904 $1
  1274. fi
  1275. # Intentamos habilitar en el arranque (Upstart)
  1276. which update-rc.d > /dev/null 2>&1
  1277. if [ $? -eq 0 ];then
  1278. update-rc.d $1 disable
  1279. comprobarError $? 905 $1
  1280. else
  1281. # Intentamos habilitar en el arranque (SystemV)
  1282. which chkconfig > /dev/null 2>&1
  1283. if [ $? -eq 0 ];then
  1284. chkconfig $1 off
  1285. comprobarError $? 905 $1
  1286. else
  1287. # ¿Qué mas opciones nos quedan?
  1288. comprobarError 1 905 $1
  1289. fi
  1290. fi
  1291. fi
  1292. # Mejora: comprobar si el servicio está funcionando
  1293. #echo -en " OK.\n" | tee -a $logFile
  1294. }
  1295. recargarServicio() {
  1296. # Recargamos el servicio (con SystemD, Upstart o SystemV)
  1297. # Intentamos con systemctl (SystemD)
  1298. #echo -en "Recargando Servicio '$1'" | tee -a $logFile
  1299. if [ $# -le 0 ];then
  1300. comprobarError 1 912
  1301. fi
  1302. which systemctl > /dev/null 2>&1
  1303. if [ $? -eq 0 ]; then
  1304. #echo -en " (SystemD)..." | tee -a $logFile
  1305. systemctl reload $1 > /dev/null 2>&1
  1306. comprobarError $? 913 $1
  1307. else
  1308. # Intentamos con service (Upstart)
  1309. which service > /dev/null 2>&1
  1310. if [ $? -eq 0 ]; then
  1311. #echo -en " (Upstart)..." | tee -a $logFile
  1312. service $1 reload > /dev/null 2>&1
  1313. comprobarError $? 913 $1
  1314. else
  1315. # Intentamos con init.d (SystemV)
  1316. #echo -en " (SystemV)..." | tee -a $logFile
  1317. /etc/init.d/$1 reload > /dev/null 2>&1
  1318. comprobarError $? 913 $1
  1319. fi
  1320. fi
  1321. # Mejora: comprobar si el servicio está funcionando
  1322. #echo -en " OK.\n" | tee -a $logFile
  1323. }
  1324. configurarCortafuegos() {
  1325. # Configuramos cortafuegos (añadir reglas y encender)
  1326. # Comprobamos si estamos usando SSH
  1327. esSSH $PPID
  1328. if [ $debianOS = true ];then
  1329. ufw allow 80/tcp >> $logFile 2>&1
  1330. comprobarError $? 906 "80/tcp"
  1331. if [ $sshControl = true ];then
  1332. ufw allow 22/tcp >> $logFile 2>&1
  1333. comprobarError $? 906 "22/tcp"
  1334. fi
  1335. if [ $sslOn = true ];then
  1336. ufw allow 443/tcp >> $logFile 2>&1
  1337. comprobarError $? 906 "443/tcp"
  1338. fi
  1339. ufw --force enable >> $logFile 2>&1
  1340. comprobarError $? 907
  1341. elif [ $rhelOS = true ];then
  1342. firewall-cmd --add-port=80/tcp >> $logFile 2>&1
  1343. comprobarError $? 906 "80/tcp"
  1344. if [ $sshControl = true ];then
  1345. firewall-cmd --add-port=22/tcp >> $logFile 2>&1
  1346. comprobarError $? 906 "22/tcp"
  1347. fi
  1348. if [ $sslOn = true ];then
  1349. firewall-cmd --add-port=443/tcp >> $logFile 2>&1
  1350. comprobarError $? 906 "443/tcp"
  1351. fi
  1352. firewall-cmd --runtime-to-permanent >> $logFile 2>&1
  1353. comprobarError $? 907
  1354. habilitarServicio firewalld >> $logFile 2>&1
  1355. comprobarError $? 907
  1356. fi
  1357. unset sshControl
  1358. }
  1359. esSSH() {
  1360. # Comprobamos si nuestro terminal usa SSH
  1361. p=${1:-$PPID}
  1362. #read pid name x ppid y < <( cat /proc/$p/stat )
  1363. read pid name ppid < <( ps -o pid= -o comm= -o ppid= -p $p)
  1364. [[ "$name" =~ sshd ]] && { sshControl=true; return 0; }
  1365. [ "$ppid" -le 1 ] && { sshControl=false; return 1; }
  1366. esSSH $ppid
  1367. }
  1368. descargarMediaWiki() {
  1369. # Descargar la versión 1.31.0 de MediaWiki
  1370. if [ ! -d ./var ];then
  1371. comprobarError 1 5 "./var"
  1372. fi
  1373. curl "https://releases.wikimedia.org/mediawiki/1.31/mediawiki-1.31.0.tar.gz" 2>/dev/null | tar -xz -C "./var/"
  1374. comprobarError $? 501
  1375. }
  1376. configurarMediaWiki() {
  1377. # Configuramos MediaWiki
  1378. if [ ! -f /var/www/$dominioMediaWiki/LocalSettings.php ];then
  1379. # Copiamos archivos
  1380. cp -fR ./var/mediawiki-1.31.0/ /var/www/$dominioMediaWiki
  1381. comprobarError $? 502
  1382. # Configuramos LocalSettings.php (y crea la base de datos por nosotros)
  1383. nombreDBMW=$(echo $dominioMediaWiki | sed -e 's/\./_/g')
  1384. userDBMW=$(echo $dominioMediaWiki | sed -e 's/\./_/g')
  1385. php /var/www/$dominioMediaWiki/maintenance/install.php --dbname=$nombreDBMW --dbserver="localhost" --installdbuser=root --installdbpass=$sqlPasswd --dbuser=$userDBMW --dbpass=$sqlPasswd --scriptpath="" --lang=es --pass=$passwdMediaWiki --with-extensions "$nombreMediaWiki" "admin" >> $logFile 2>&1
  1386. comprobarError $? 502
  1387. # Configuraciones adicionales
  1388. sed -i '/$wgLanguageCode =/c\$wgLanguageCode = "es";' /var/www/$dominioMediaWiki/LocalSettings.php
  1389. comprobarError $? 502
  1390. sed -i '/$wgEnableEmail =/c\$wgEnableEmail = false;' /var/www/$dominioMediaWiki/LocalSettings.php
  1391. comprobarError $? 502
  1392. sed -i '/$wgEnableUploads =/c\$wgEnableUploads = true;' /var/www/$dominioMediaWiki/LocalSettings.php
  1393. comprobarError $? 502
  1394. echo -en "\$wgArticlePath = \"/wiki/\$1\";\n" >> /var/www/$dominioMediaWiki/LocalSettings.php
  1395. echo -en "\$wgUsePathInfo = true;\n" >> /var/www/$dominioMediaWiki/LocalSettings.php
  1396. echo -en "\$wgGroupPermissions['*']['createaccount'] = true;\n" >> /var/www/$dominioMediaWiki/LocalSettings.php
  1397. echo -en "\$wgGroupPermissions['*']['edit'] = false;\n" >> /var/www/$dominioMediaWiki/LocalSettings.php
  1398. echo -en "\$wgGroupPermissions['*']['read'] = true;\n" >> /var/www/$dominioMediaWiki/LocalSettings.php
  1399. # Actualizamos permisos
  1400. chown -R $webServerUser:$webServerGroup /var/www/$dominioMediaWiki
  1401. comprobarError $? 502
  1402. # Configuramos VirtualHost
  1403. if [ $apacheOn = true ] && [ $sslOn = false ];then
  1404. virtualHost="./etc/apache2/sites-available/mediawiki.conf"
  1405. elif [ $nginxOn = true ] && [ $sslOn = false ];then
  1406. virtualHost="./etc/nginx/sites-available/mediawiki.conf"
  1407. elif [ $apacheOn = true ] && [ $sslOn = true ];then
  1408. virtualHost="./etc/apache2/sites-available/mediawiki-ssl.conf"
  1409. elif [ $nginxOn = true ] && [ $sslOn = true ];then
  1410. virtualHost="./etc/nginx/sites-available/mediawiki-ssl.conf"
  1411. else
  1412. comprobarError 1 502
  1413. fi
  1414. if [ ! -f $virtualHost ];then
  1415. comprobarError $? 502
  1416. fi
  1417. instalarVirtualHost "/var/www/$dominioMediaWiki" $virtualHost $dominioMediaWiki $aliasMediaWiki
  1418. unset virtualHost
  1419. else
  1420. comprobarError 1 503 $dominioMediaWiki
  1421. fi
  1422. }
  1423. descargarMoodle() {
  1424. # Descargar la versión 1.31.0 de MediaWiki
  1425. if [ ! -d ./var ];then
  1426. comprobarError 1 5 "./var"
  1427. fi
  1428. #echo -en "Descargando Moodle-3.5-1..." | tee -a $logFile
  1429. #curl -o "./var/moodle-3.5.1.tgz" "https://download.moodle.org/download.php/direct/stable35/moodle-latest-35.tgz" >> $logFile 2>&1
  1430. curl "https://download.moodle.org/download.php/direct/stable35/moodle-latest-35.tgz" 2>/dev/null | tar -xz -C "./var/"
  1431. comprobarError $? 501
  1432. #echo -en " OK.\n" | tee -a $logFile
  1433. }
  1434. configurarMoodle() {
  1435. # Configurar Moodle
  1436. if [ ! -f /var/www/$dominioMoodle/config.php ];then
  1437. # Copiamos archivos
  1438. cp -Rf ./var/moodle/ /var/www/$dominioMoodle
  1439. comprobarError $? 602
  1440. # Crear carperta de datos (no online)
  1441. if [ ! -d /var/www/moodledata ];then
  1442. mkdir /var/www/moodledata 2>/dev/null
  1443. comprobarError $? 602
  1444. fi
  1445. #Actualizamos permisos
  1446. perm=$(stat -c %a /var/www/moodledata)
  1447. if [ $perm -ne 777 ];then
  1448. chmod -R 777 /var/www/moodledata 2>/dev/null
  1449. comprobarError $? 602
  1450. fi
  1451. perm=$(stat -c %U /var/www/moodledata)
  1452. if [ $perm != "$webServerUser" ];then
  1453. chown -R $webServerUser:$webServerGroup /var/www/moodledata 2>/dev/null
  1454. comprobarError $? 602
  1455. fi
  1456. unset perm
  1457. # Creamos Base de Datos
  1458. nombreDBMo=$(echo $dominioMoodle | sed -e 's/\./_/g')
  1459. userDBMo=$(echo $dominioMoodle | sed -e 's/\./_/g')
  1460. crearDBMoodle
  1461. # Configurar SE-Linux (RHEL)
  1462. if [ $rhelOS = true ];then
  1463. configurarSELinux
  1464. fi
  1465. # Configuramos e instalamos Moodle
  1466. if [ $sslOn = true ];then
  1467. wwwroot="https://$dominioMoodle"
  1468. else
  1469. wwwroot="http://$dominioMoodle"
  1470. fi
  1471. if [ $mySQLOn = true ];then
  1472. dbtype="mysqli"
  1473. elif [ $mariaDBOn = true ];then
  1474. dbtype="mariadb"
  1475. else
  1476. comprobarError 1 602
  1477. fi
  1478. php /var/www/$dominioMoodle/admin/cli/install.php --lang=es --wwwroot="$wwwroot" --dataroot="/var/www/moodledata" --dbtype="$dbtype" --dbname="$nombreDBMo" --dbuser="$userDBMo" --dbpass="$sqlPasswd" --fullname="$nombreMoodle" --shortname="$nombreCortoMoodle" --adminuser=admin --adminpass="$passwdMoodle" --adminemail="admin@$dominioMoodle" --agree-license --non-interactive >>$logFile 2>&1
  1479. comprobarError $? 602
  1480. # Actualizamos permisos
  1481. chown -R $webServerUser:$webServerGroup /var/www/$dominioMoodle /var/www/moodledata
  1482. # Configuramos VirtualHost
  1483. if [ $apacheOn = true ] && [ $sslOn = false ];then
  1484. virtualHost="./etc/apache2/sites-available/moodle.conf"
  1485. elif [ $nginxOn = true ] && [ $sslOn = false ];then
  1486. virtualHost="./etc/nginx/sites-available/moodle.conf"
  1487. elif [ $apacheOn = true ] && [ $sslOn = true ];then
  1488. virtualHost="./etc/apache2/sites-available/moodle-ssl.conf"
  1489. elif [ $nginxOn = true ] && [ $sslOn = true ];then
  1490. virtualHost="./etc/nginx/sites-available/moodle-ssl.conf"
  1491. else
  1492. comprobarError 1 602
  1493. fi
  1494. instalarVirtualHost "/var/www/$dominioMoodle" $virtualHost $dominioMoodle
  1495. unset virtualHost wwwroot dbtype
  1496. else
  1497. comprobarError 1 603 $dominioMoodle
  1498. fi
  1499. }
  1500. crearDBMoodle() {
  1501. # Crear base de datos para Moodle
  1502. dbDir="./etc/db"
  1503. if [ ! -d $dbDir ];then
  1504. mkdir $dbDir 2>/dev/null
  1505. comprobarError $? 503
  1506. fi
  1507. dbFile=$dbDir"/moodle.sql"
  1508. echo -en "CREATE DATABASE IF NOT EXISTS $nombreDBMo DEFAULT CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;\n" > $dbFile
  1509. echo -en "GRANT ALL PRIVILEGES ON $nombreDBMo.* TO '$userDBMo'@'localhost' IDENTIFIED BY '$sqlPasswd';\n" >> $dbFile
  1510. mysql -u root --password=$sqlPasswd < $dbFile > /dev/null 2>&1
  1511. control=$?
  1512. rm -f $dbFile 2>/dev/null
  1513. comprobarError $? 503
  1514. comprobarError $control 503
  1515. unset control dbFile dbDir
  1516. }
  1517. configurarSELinux() {
  1518. # Configurar SELinux (Sólo para RHEL)
  1519. which semanage >/dev/null 2>&1
  1520. if [ $? -ne 0 ];then
  1521. result=$(yum -y install policycoreutils-python 2>&1)
  1522. comprobarError $? 605 $result
  1523. fi
  1524. semanage fcontext -a -t httpd_sys_rw_content_t "/var/www/moodledata(/.*)?" > /dev/null 2>&1
  1525. comprobarError $? 604
  1526. restorecon -R /var/www/ > /dev/null 2>&1
  1527. comprobarError $? 604
  1528. }
  1529. instalarPHPInfo() {
  1530. # Instalar fichero info.php y su VirtualHost
  1531. if [ ! -f /etc/$webServerName/sites-enabled/phpinfo.conf ];then
  1532. infoFile="./var/www/info.php"
  1533. if [ ! -f $infoFile ];then
  1534. comprobarError 1 4 "$infoFile"
  1535. fi
  1536. mkdir /var/www/localhost 2>/dev/null
  1537. comprobarError $? 106
  1538. cp -f $infoFile /var/www/localhost/ 2>/dev/null
  1539. comprobarError $? 106
  1540. chown -R $webServerUser:$webServerGroup /var/www/localhost 2>/dev/null
  1541. comprobarError $? 106
  1542. unset infoFile
  1543. # Instalar VirtualHost
  1544. if [ $apacheOn = true ] && [ $sslOn = false ];then
  1545. virtualHost="./etc/apache2/sites-available/phpinfo.conf"
  1546. elif [ $nginxOn = true ] && [ $sslOn = false ];then
  1547. virtualHost="./etc/nginx/sites-available/phpinfo.conf"
  1548. elif [ $apacheOn = true ] && [ $sslOn = true ];then
  1549. virtualHost="./etc/apache2/sites-available/phpinfo-ssl.conf"
  1550. elif [ $nginxOn = true ] && [ $sslOn = true ];then
  1551. virtualHost="./etc/nginx/sites-available/phpinfo-ssl.conf"
  1552. else
  1553. comprobarError 1 106
  1554. fi
  1555. instalarVirtualHost "/var/www/localhost" $virtualHost "localhost"
  1556. unset virtualHost
  1557. return 0
  1558. else
  1559. return 1
  1560. fi
  1561. }
  1562. # Comprobación del sistema e inicialización
  1563. inicializarVariables
  1564. comprobarRoot
  1565. OSInfo
  1566. comprobarDependencias
  1567. # Bienvenida
  1568. mostrarBienvenida
  1569. # Selección de componentes (express vs avanzada)
  1570. mostrarExpress
  1571. # Instalación Servidor Web
  1572. if [ $apacheOn = true ]; then
  1573. echo -en "Instalando Servidor Web Apache..." | tee -a $logFile
  1574. instalarApache
  1575. echo -en " OK.\n" | tee -a $logFile
  1576. elif [ $nginxOn = true ]; then
  1577. echo -en "Instalando Servidor Web Nginx..." | tee -a $logFile
  1578. instalarNginx
  1579. echo -en " OK.\n" | tee -a $logFile
  1580. fi
  1581. # Instalación Base de Datos
  1582. if [ $mySQLOn = true ]; then
  1583. echo -en "Instalando Base de Datos MySQL..." | tee -a $logFile
  1584. instalarMySQL
  1585. echo -en " OK.\n" | tee -a $logFile
  1586. elif [ $mariaDBOn = true ]; then
  1587. echo -en "Instalando Base de Datos MariaDB..." | tee -a $logFile
  1588. instalarMariaDB
  1589. echo -en " OK.\n" | tee -a $logFile
  1590. fi
  1591. # Instalación PHP-7.2
  1592. if [ $phpOn = true ]; then
  1593. echo -en "Instalando PHP-7..." | tee -a $logFile
  1594. instalarPHP
  1595. echo -en " OK.\n" | tee -a $logFile
  1596. fi
  1597. # Instalación Let's Encrypt
  1598. if [ $letsEncryptOn = true ];then
  1599. echo -en "Instalando Let's Encrypt..." | tee -a $logfile
  1600. instalarLetsEncrypt
  1601. echo -en " OK.\n" | tee -a $logFile
  1602. fi
  1603. # Configuración Web Server
  1604. if [ $apacheOn = true ];then
  1605. echo -en "Configurando Servidor Web Apache..." | tee -a $logFile
  1606. configurarApache
  1607. echo -en " OK.\n" | tee -a $logFile
  1608. elif [ $nginxOn = true ]; then
  1609. echo -en "Configurando Servidor Web Nginx..." | tee -a $logFile
  1610. configurarNginx
  1611. echo -en " OK.\n" | tee -a $logFile
  1612. fi
  1613. # Configuración Database (Arrancar Base de Datos, establecer contraseña y configuración segura)
  1614. if [ $mySQLOn = true ] || [ $mariaDBOn = true ];then
  1615. echo -en "Configurando Base de Datos..." | tee -a $logFile
  1616. configurarSQL
  1617. echo -en " OK.\n" | tee -a $logFile
  1618. habilitarServicio "$sqlServerName"
  1619. echo -en "Estableciendo contraseña de la Base de Datos..." | tee -a $logFile
  1620. establecerSQLPasswd
  1621. echo -en " OK.\n" | tee -a $logFile
  1622. fi
  1623. # Configuración PHP (cgi.fix_pathinfo=0 y Configurar máximo de subida de archivos)
  1624. if [ $phpOn = true ];then
  1625. echo -en "Configurando PHP-7..." | tee -a $logFile
  1626. configurarPHP
  1627. echo -en " OK.\n" | tee -a $logFile
  1628. fi
  1629. # Configuración SSL/TLS
  1630. # Generar certificados
  1631. # Configurar certificados
  1632. if [ $sslOn = true ];then
  1633. echo -en "Configurando SSL/TLS..." | tee -a $logFile
  1634. sleep 2
  1635. echo -en " OK.\n" | tee -a $logFile
  1636. fi
  1637. # Arrancar y habilitar todos los servicios (SystemD, Service o SystemV)
  1638. echo -en "Habilitando todos los servicios..." | tee -a $logFile
  1639. if [ $apacheOn = true ];then
  1640. habilitarServicio $webServerName
  1641. elif [ $nginxOn = true ];then
  1642. habilitarServicio $webServerName
  1643. if [ $phpOn = true ];then
  1644. habilitarServicio $phpFPMName
  1645. fi
  1646. fi
  1647. echo -en " OK.\n" | tee -a $logFile
  1648. # MediaWiki
  1649. if [ $mediaWikiOn = true ]; then
  1650. # Descargar MediaWiki
  1651. echo -en "Descargando MediaWiki-1.31.0..." | tee -a $logFile
  1652. descargarMediaWiki
  1653. echo -en " OK.\n" | tee -a $logFile
  1654. # Configurar MediWiki
  1655. echo -en "Configurando MediaWiki..." | tee -a $logFile
  1656. configurarMediaWiki
  1657. echo -en " OK.\n" | tee -a $logFile
  1658. fi
  1659. # Moodle
  1660. if [ $moodleOn = true ]; then
  1661. # Descargar Moodle
  1662. echo -en "Descargando Moodle-3.5.1..." | tee -a $logFile
  1663. descargarMoodle
  1664. echo -en " OK.\n" | tee -a $logFile
  1665. # Configuración Moodle
  1666. echo -en "Configurando Moodle (puede llevar un tiempo largo)..." | tee -a $logFile
  1667. configurarMoodle
  1668. echo -en " OK.\n" | tee -a $logFile
  1669. fi
  1670. # Configurar Virtual Hosts
  1671. # Instalar info.php
  1672. if [ $infoPHPOn = true ];then
  1673. echo -en "Configurando 'info.php'..." | tee -a $logFile
  1674. instalarPHPInfo
  1675. if [ $? -eq 0 ];then
  1676. echo -en " OK.\n" | tee -a $logFile
  1677. else
  1678. echo -en " Ya se encuentra configurado.\n" | tee -a $logFile
  1679. fi
  1680. fi
  1681. # Añadir reglas del cortafuegos
  1682. echo -en "Configurando Cortafuegos..." | tee -a $logFile
  1683. configurarCortafuegos
  1684. echo -en " OK.\n" | tee -a $logFile
  1685. # Configurar Backup
  1686. if [ $backupOn = true ]; then
  1687. echo -en "Configurando Backup Automático..." | tee -a $logFile
  1688. sleep 2
  1689. echo -en " OK.\n" | tee -a $logFile
  1690. fi